
;
;   Simple assembler test for VAX.  Uses the base address at 'base'
;   and the number of bytes at 'count' to write NOP instructions
;   over memory.  It then jumps to the NOP stream and executes it.
;

        .print    "    Loop test V1.1"
        .print    "(C) 1998 Forest Edge Software"
        .print    "    All Rights Reserved."
        
        .base     200

entry:  jmp       main

base:   .long     ^x00000300           ; starting address to write to
count:  .long     ^d60000              ; number of bytes to write


main:   movl      base, r0
        movl      count, r1

loop:   movb      #OPC$_NOP, (r0)       ; The OPC$_* symbols are predefined
        incl      r0
        sobgtr    r1, loop

done:   movb      #OPC$_HALT, (r0)
        movl      #base, r2
        jmp       (r2)
        halt

        end       entry



